<?php

/**
 * Import/Export plugin
 *
 *
 * Created: 2007-05-12
 * Last update: 2007-05-18
 *
 * @link http://deboutv.free.fr/mantis/
 * @author DEBOUT Vincent  <deboutv@free.fr>
 */

function plugins_importexport_filter_draw_selection_area( $p_project_id ) {
    global $g_mantis_is_11x_release;
    
    $t_filter = current_user_get_bug_filter();
    $t_filter = filter_ensure_valid_filter( $t_filter );
    $t_project_id = $p_project_id;

    $t_view_type = $t_filter['_view_type'];

    $t_tdclass = 'small-caption';
    $t_trclass = 'row-category2';
    $t_action  = 'view_all_set.php?f=3';

    echo '<table class="width100" cellspacing="1">' . "\n";
    $t_filter_cols = config_get( 'filter_custom_fields_per_row' );
    $t_custom_cols = $t_filter_cols;

    $t_current_user_access_level = current_user_get_access_level();
    $t_accessible_custom_fields_ids = array();
    $t_accessible_custom_fields_names = array();
    $t_accessible_custom_fields_values = array();
    $t_num_custom_rows = 0;
    $t_per_row = 0;

    if ( ON == config_get( 'filter_by_custom_fields' ) ) {
        $t_custom_fields = custom_field_get_linked_ids( $t_project_id );

        foreach ( $t_custom_fields as $t_cfid ) {
            $t_field_info = custom_field_cache_row( $t_cfid, true );
            if ( $t_field_info['access_level_r'] <= $t_current_user_access_level ) {
                $t_accessible_custom_fields_ids[] = $t_cfid;
                $t_accessible_custom_fields_names[] = $t_field_info['name'];
                $t_accessible_custom_fields_types[] = $t_field_info['type'];
                $t_accessible_custom_fields_values[] = custom_field_distinct_values( $t_cfid );
            }
        }
        
        if ( count( $t_accessible_custom_fields_ids ) > 0 ) {
            $t_per_row = config_get( 'filter_custom_fields_per_row' );
            $t_num_custom_rows = ceil( count( $t_accessible_custom_fields_ids ) / $t_per_row );
        }
    }

    $t_filters_url = 'view_filters_page.php?for_screen=on';
    $t_filters_url = $t_filters_url . '&amp;view_type=advanced';
    $t_filters_url = $t_filters_url . '&amp;target_field=';

    $t_show_version = ( ON == config_get( 'show_product_version' ) )
      || ( ( AUTO == config_get( 'show_product_version' ) )
          && ( count( version_get_all_rows_with_subs( $t_project_id ) ) > 0 ) );
    if ( ! access_has_project_level( config_get( 'view_handler_threshold' ), $t_project_id ) ) { 
        $t_filter['handler_id'] = array( META_FILTER_ANY ); 
    } 

    echo '<tr class="' . $t_trclass . '">' . "\n";
    echo '<td class="small-caption" valign="top">';
    echo '<a href="' . $t_filters_url . 'reporter_id[]" id="reporter_id_filter">' . lang_get( 'reporter' ) . ':</a>';
    echo '</td>' . "\n";
    echo '<td class="small-caption" valign="top">';
    echo '<a href="' . $t_filters_url . 'user_monitor[]" id="user_monitor_filter">' . lang_get( 'monitored_by' ) . ':</a>';
    echo '</td>' . "\n";
    echo '<td class="small-caption" valign="top">';
    echo '<a href="' . $t_filters_url . 'handler_id[]" id="handler_id_filter">' . lang_get( 'assigned_to' ) . ':</a>';
    echo '</td>' . "\n";
    echo '<td colspan="2" class="small-caption" valign="top">';
    echo '<a href="' . $t_filters_url . 'show_category[]" id="show_category_filter">' . lang_get( 'category' ) . ':</a>';
    echo '</td>' . "\n";
    echo '<td class="small-caption" valign="top">';
    echo '<a href="' . $t_filters_url . 'show_severity[]" id="show_severity_filter">' . lang_get( 'severity' ) . ':</a>';
    echo '</td>' . "\n";
    echo '<td class="small-caption" valign="top">';
    echo '<a href="' . $t_filters_url . 'show_resolution[]" id="show_resolution_filter">' . lang_get( 'resolution' ) . ':</a>';
    echo '</td>' . "\n";
    echo '<td class="small-caption" valign="top">';
    echo '<a href="' . $t_filters_url . 'show_profile[]" id="show_profile_filter">' . lang_get( 'profile' ) . ':</a>';
    echo '</td>' . "\n";
    if ( $t_filter_cols > 8 ) {
        echo '<td class="small-caption" valign="top" colspan="' . ( $t_filter_cols - 8 ) . '">&nbsp;</td>' . "\n";
    }
    echo '</tr>' . "\n";
    echo '<tr class="row-1">' . "\n";
    echo '<td class="small-caption" valign="top" id="reporter_id_filter_target">';
    $t_output = '';
    $t_any_found = false;
    if ( count( $t_filter['reporter_id'] ) == 0 ) {
        echo lang_get( 'any' );
    } else {
        $t_first_flag = true;
        foreach( $t_filter['reporter_id'] as $t_current ) {
            $t_this_name = '';
            echo '<input type="hidden" name="reporter_id[]" value="' . $t_current . '" />' . "\n";
            if ( ( $t_current === 0 ) || ( is_blank( $t_current ) ) || ( META_FILTER_ANY == $t_current ) ) {
                $t_any_found = true;
            } else if ( META_FILTER_MYSELF == $t_current ) {
                if ( access_has_project_level( config_get( 'report_bug_threshold' ) ) ) {
                    $t_this_name = '[' . lang_get( 'myself' ) . ']';
                } else {
                    $t_any_found = true;
                }
            } else if ( META_FILTER_NONE == $t_current ) {
                $t_this_name = lang_get( 'none' );
            } else {
                $t_this_name = user_get_name( $t_current );
            }
            if ( $t_first_flag != true ) {
                $t_output = $t_output . '<br />';
            } else {
                $t_first_flag = false;
            }
            $t_output = $t_output . $t_this_name;
        }
        if ( true == $t_any_found ) {
            echo lang_get( 'any' );
        } else {
            echo $t_output;
        }
    }
    echo '</td>' . "\n";
    echo '<td class="small-caption" valign="top" id="user_monitor_filter_target">';
    $t_output = '';
    $t_any_found = false;
    if ( count( $t_filter['user_monitor'] ) == 0 ) {
        echo lang_get( 'any' );
    } else {
        $t_first_flag = true;
        foreach( $t_filter['user_monitor'] as $t_current ) {
            echo '<input type="hidden" name="user_monitor[]" value="' . $t_current . '" />';
            $t_this_name = '';
            if ( ( $t_current === 0 ) || ( is_blank( $t_current ) ) || ( META_FILTER_ANY == $t_current ) ) {
                $t_any_found = true;
            } else if ( META_FILTER_MYSELF == $t_current ) {
                if ( access_has_project_level( config_get( 'monitor_bug_threshold' ) ) ) {
                    $t_this_name = '[' . lang_get( 'myself' ) . ']';
                } else {
                    $t_any_found = true;
                }
            } else {
                $t_this_name = user_get_name( $t_current );
            }
            if ( $t_first_flag != true ) {
                $t_output = $t_output . '<br />';
            } else {
                $t_first_flag = false;
            }
            $t_output = $t_output . $t_this_name;
        }
        if ( true == $t_any_found ) {
            echo lang_get( 'any' );
        } else {
            echo $t_output;
        }
    }
    echo '</td>' . "\n";
    echo '<td class="small-caption" valign="top" id="handler_id_filter_target">';
    $t_output = '';
    $t_any_found = false;
    if ( count( $t_filter['handler_id'] ) == 0 ) {
        echo lang_get( 'any' );
    } else {
        $t_first_flag = true;
        foreach( $t_filter['handler_id'] as $t_current ) {
            echo '<input type="hidden" name="handler_id[]" value="' . $t_current . '" />';
            $t_this_name = '';
            if ( META_FILTER_NONE == $t_current ) {
                $t_this_name = lang_get( 'none' );
            } else if ( ( $t_current === 0 ) || ( is_blank( $t_current ) ) || ( META_FILTER_ANY == $t_current ) ) {
                $t_any_found = true;
            } else if ( META_FILTER_MYSELF == $t_current ) {
                if ( access_has_project_level( config_get( 'handle_bug_threshold' ) ) ) {
                    $t_this_name = '[' . lang_get( 'myself' ) . ']';
                } else {
                    $t_any_found = true;
                }
            } else {
                $t_this_name = user_get_name( $t_current );
            }
            if ( $t_first_flag != true ) {
                $t_output = $t_output . '<br />';
            } else {
                $t_first_flag = false;
            }
            $t_output = $t_output . $t_this_name;
        }
        if ( true == $t_any_found ) {
            echo lang_get( 'any' );
        } else {
            echo $t_output;
        }
    }
    echo '</td>' . "\n";
    echo '<td colspan="2" class="small-caption" valign="top" id="show_category_filter_target">';
    $t_output = '';
    $t_any_found = false;
    if ( count( $t_filter['show_category'] ) == 0 ) {
        echo lang_get( 'any' );
    } else {
        $t_first_flag = true;
        foreach( $t_filter['show_category'] as $t_current ) {
            $t_current = stripslashes( $t_current );
            echo '<input type="hidden" name="show_category[]" value="' . string_display( $t_current ) . '" />';
            $t_this_string = '';
            if ( ( ( $t_current == META_FILTER_ANY ) && ( is_numeric( $t_current ) ) ) 
                || ( is_blank( $t_current ) ) ) {
                $t_any_found = true;
            } else {
                $t_this_string = string_display( $t_current );
            }
            if ( $t_first_flag != true ) {
                $t_output = $t_output . '<br />';
            } else {
                $t_first_flag = false;
            }
            $t_output = $t_output . $t_this_string;
        }
        if ( true == $t_any_found ) {
            echo lang_get( 'any' );
        } else {
            echo $t_output;
        }
    }
    echo '</td>' . "\n";
    echo '<td class="small-caption" valign="top" id="show_severity_filter_target">';
    $t_output = '';
    $t_any_found = false;
    if ( count( $t_filter['show_severity'] ) == 0 ) {
        echo lang_get( 'any' );
    } else {
        $t_first_flag = true;
        foreach( $t_filter['show_severity'] as $t_current ) {
            echo '<input type="hidden" name="show_severity[]" value="' . $t_current . '" />';
            $t_this_string = '';
            if ( ( $t_current === META_FILTER_ANY ) || ( is_blank( $t_current ) ) || ( $t_current == 0 ) ) {
                $t_any_found = true;
            } else {
                $t_this_string = get_enum_element( 'severity', $t_current );
            }
            if ( $t_first_flag != true ) {
                $t_output = $t_output . '<br />';
            } else {
                $t_first_flag = false;
            }
            $t_output = $t_output . $t_this_string;
        }
        if ( true == $t_any_found ) {
            echo lang_get( 'any' );
        } else {
            echo $t_output;
        }
    }
    echo '</td>' . "\n";
    echo '<td class="small-caption" valign="top" id="show_resolution_filter_target">';
    $t_output = '';
    $t_any_found = false;
    if ( count( $t_filter['show_resolution'] ) == 0 ) {
        echo lang_get( 'any' );
    } else {
        $t_first_flag = true;
        foreach( $t_filter['show_resolution'] as $t_current ) {
            echo '<input type="hidden" name="show_resolution[]" value="' . $t_current . '" />';
            $t_this_string = '';
            if ( ( $t_current === META_FILTER_ANY ) || ( is_blank( $t_current ) ) || ( $t_current === 0 ) ) {
                $t_any_found = true;
            } else {
                $t_this_string = get_enum_element( 'resolution', $t_current );
            }
            if ( $t_first_flag != true ) {
                $t_output = $t_output . '<br />';
            } else {
                $t_first_flag = false;
            }
            $t_output = $t_output . $t_this_string;
        }
        if ( true == $t_any_found ) {
            echo lang_get( 'any' );
        } else {
            echo $t_output;
        }
    }
    echo '</td>' . "\n";
    echo '<td class="small-caption" valign="top" id="show_profile_filter_target">';
    $t_output = '';
    $t_any_found = false;
    if ( count( $t_filter['show_profile'] ) == 0 ) {
        echo lang_get( 'any' );
    } else {
        $t_first_flag = true;
        foreach( $t_filter['show_profile'] as $t_current ) {
            echo '<input type="hidden" name="show_profile[]" value="' . $t_current . '" />';
            $t_this_string = '';
            if ( ( $t_current === META_FILTER_ANY ) || ( is_blank( $t_current ) ) || ( $t_current === 0 ) ) {
                $t_any_found = true;
            } else {
                $t_profile = profile_get_row_direct( $t_current );

                $t_this_string = "${t_profile['platform']} ${t_profile['os']} ${t_profile['os_build']}";
            }
            if ( $t_first_flag != true ) {
                $t_output = $t_output . '<br />';
            } else {
                $t_first_flag = false;
            }
            $t_output = $t_output . $t_this_string;
        }
        if ( true == $t_any_found ) {
            echo lang_get( 'any' );
        } else {
            echo $t_output;
        }
    }
    echo '</td>' . "\n";
    if ( $t_filter_cols > 8 ) {
        echo '<td class="small-caption" valign="top" colspan="' . ( $t_filter_cols - 8 ) . '">&nbsp;</td>';
    }   
    echo '</tr>' . "\n";
    echo '<tr class="' . $t_trclass . '">' . "\n";
    echo '<td class="small-caption" valign="top">';
    echo '<a href="' . $t_filters_url . 'show_status[]" id="show_status_filter">' . lang_get( 'status' ) . ':</a>';
    echo '</td>' . "\n";
    echo '<td class="small-caption" valign="top">';
    echo '</td>' . "\n";
    echo '<td class="small-caption" valign="top">';
    echo '<a href="' . $t_filters_url . 'show_build[]" id="show_build_filter">' . lang_get( 'product_build' ) . ':</a>';
    echo '</td>' . "\n";
    if ( $t_show_version ) {
        echo '<td colspan="2" class="small-caption" valign="top">';
        echo '<a href="' . $t_filters_url . 'show_version[]" id="show_version_filter">' . lang_get( 'product_version' ) . ':</a>';
        echo '</td>' . "\n";
        echo '<td colspan="1" class="small-caption" valign="top">';
        echo '<a href="' . $t_filters_url . 'fixed_in_version[]" id="show_fixed_in_version_filter">' . lang_get( 'fixed_in_version' ) . ':</a>';
        echo '</td>' . "\n";
    } else {
        echo '<td colspan="2" class="small-caption" valign="top">&nbsp;</td>' . "\n";
        echo '<td colspan="1" class="small-caption" valign="top">&nbsp;</td>' . "\n";
    }
    echo '<td colspan="1" class="small-caption" valign="top">';
    echo '<a href="' . $t_filters_url . 'show_priority[]" id="show_priority_filter">' . lang_get( 'priority' ) . ':</a>';
    echo '</td>' . "\n";
    echo '<td colspan="1" class="small-caption" valign="top">';
    if ( $g_mantis_is_11x_release ) {
        echo '<a href="' . $t_filters_url . 'target_version[]" id="show_target_version_filter">' . lang_get( 'target_version' ) . ':</a>';
    } else {
        echo '&nbsp;';
    }
    echo '</td>' . "\n";
    if ( $t_filter_cols > 8 ) {
        echo '<td class="small-caption" valign="top" colspan="' . ( $t_filter_cols - 7 ) . '">&nbsp;</td>' . "\n";
    }
    echo '</tr>' . "\n";
    echo '<tr class="row-1">' . "\n";
    echo '<td class="small-caption" valign="top" id="show_status_filter_target">' . "\n";
    $t_output = '';
    $t_any_found = false;
    if ( count( $t_filter['show_status'] ) == 0 ) {
        echo lang_get( 'any' );
    } else {
        $t_first_flag = true;
        foreach( $t_filter['show_status'] as $t_current ) {
            echo '<input type="hidden" name="show_status[]" value="' . $t_current . '" />';
            $t_this_string = '';
            if ( ( $t_current === META_FILTER_ANY ) || ( is_blank( $t_current ) ) || ( $t_current === 0 ) ) {
                $t_any_found = true;
            } else {
                $t_this_string = get_enum_element( 'status', $t_current );
            }
            if ( $t_first_flag != true ) {
                $t_output = $t_output . '<br />';
            } else {
                $t_first_flag = false;
            }
            $t_output = $t_output . $t_this_string;
        }
        if ( true == $t_any_found ) {
            echo lang_get( 'any' );
        } else {
            echo $t_output;
        }
    }
    echo '</td>' . "\n";
    echo '<td class="small-caption" valign="top" id="hide_status_filter_target"></td>' . "\n";
    echo '<td class="small-caption" valign="top" id="show_build_filter_target">';
    $t_output = '';
    $t_any_found = false;
    if ( count( $t_filter['show_build'] ) == 0 ) {
        echo lang_get( 'any' );
    } else {
        $t_first_flag = true;
        foreach( $t_filter['show_build'] as $t_current ) {
            $t_current = stripslashes( $t_current );
            echo '<input type="hidden" name="show_build[]" value="' . string_display( $t_current ) . '" />';
            $t_this_string = '';
            if ( ( ( $t_current == META_FILTER_ANY ) && ( is_numeric( $t_current ) ) ) 
                || ( is_blank( $t_current ) ) ) {
                $t_any_found = true;
            } else if ( META_FILTER_NONE == $t_current ) {
                $t_this_string = lang_get( 'none' );
            } else {
                $t_this_string = string_display( $t_current );
            }
            if ( $t_first_flag != true ) {
                $t_output = $t_output . '<br />';
            } else {
                $t_first_flag = false;
            }
            $t_output = $t_output . $t_this_string;
        }
        if ( true == $t_any_found ) {
            echo lang_get( 'any' );
        } else {
            echo $t_output;
        }
    }
    echo '</td>' . "\n";
    if ( $t_show_version ) {
        echo '<td colspan="2" class="small-caption" valign="top" id="show_version_filter_target">';
        $t_output = '';
        $t_any_found = false;
        if ( count( $t_filter['show_version'] ) == 0 ) {
            echo lang_get( 'any' );
        } else {
            $t_first_flag = true;
            foreach( $t_filter['show_version'] as $t_current ) {
                $t_current = stripslashes( $t_current );
                echo '<input type="hidden" name="show_version[]" value="' . string_display( $t_current ) . '" />';
                $t_this_string = '';
                if ( ( ( $t_current == META_FILTER_ANY ) && (is_numeric( $t_current ) ) ) 
                    || ( is_blank( $t_current ) ) ) {
                    $t_any_found = true;
                } else if ( META_FILTER_NONE == $t_current ) {
                    $t_this_string = lang_get( 'none' );
                } else {
                    $t_this_string = string_display( $t_current );
                }
                if ( $t_first_flag != true ) {
                    $t_output = $t_output . '<br />';
                } else {
                    $t_first_flag = false;
                }
                $t_output = $t_output . $t_this_string;
            }
            if ( true == $t_any_found ) {
                echo lang_get( 'any' );
            } else {
                echo $t_output;
            }
        }
        echo '</td>' . "\n";
        echo '<td colspan="1" class="small-caption" valign="top" id="show_fixed_in_version_filter_target">';
        $t_output = '';
        $t_any_found = false;
        if ( count( $t_filter['fixed_in_version'] ) == 0 ) {
            echo lang_get( 'any' );
        } else {
            $t_first_flag = true;
            foreach( $t_filter['fixed_in_version'] as $t_current ) {
                $t_current = stripslashes( $t_current );
                echo '<input type="hidden" name="fixed_in_version[]" value="' . string_display( $t_current ) . '" />';
                $t_this_string = '';
                if ( ( ( $t_current == META_FILTER_ANY ) && ( is_numeric( $t_current ) ) ) 
                    || ( is_blank( $t_current ) ) ) {
                    $t_any_found = true;
                } else if ( META_FILTER_NONE == $t_current ) {
                    $t_this_string = lang_get( 'none' );
                } else {
                    $t_this_string = string_display( $t_current );
                }
                if ( $t_first_flag != true ) {
                    $t_output = $t_output . '<br />';
                } else {
                    $t_first_flag = false;
                }
                $t_output = $t_output . $t_this_string;
            }
            if ( true == $t_any_found ) {
                echo lang_get( 'any' );
            } else {
                echo $t_output;
            }
        }
        echo '</td>' . "\n";
    } else { 
        echo '<td colspan="2" class="small-caption" valign="top">&nbsp;</td>' . "\n";
        echo '<td colspan="1" class="small-caption" valign="top">&nbsp;</td>' . "\n";
    }
    echo '<td colspan="1" class="small-caption" valign="top" id="show_priority_filter_target">';
    $t_output = '';
    $t_any_found = false;
    if ( count( $t_filter['show_priority'] ) == 0 ) {
        echo lang_get( 'any' );
    } else {
        $t_first_flag = true;
        foreach( $t_filter['show_priority'] as $t_current ) {
            echo '<input type="hidden" name="show_priority[]" value="' . $t_current . '" />';
            $t_this_string = '';
            if ( ( $t_current === META_FILTER_ANY ) || ( is_blank( $t_current ) ) || ( $t_current === 0 ) ) {
                $t_any_found = true;
            } else {
                $t_this_string = get_enum_element( 'priority', $t_current );
            }
            if ( $t_first_flag != true ) {
                $t_output = $t_output . '<br />';
            } else {
                $t_first_flag = false;
            }
            $t_output = $t_output . $t_this_string;
        }
        if ( true == $t_any_found ) {
            echo lang_get( 'any' );
        } else {
            echo $t_output;
        }
    }
    echo '</td>' . "\n";
    echo '<td colspan="1" class="small-caption" valign="top" id="show_target_version_filter_target">';
    if ( $g_mantis_is_11x_release ) {
        $t_output = '';
        $t_any_found = false;
        if ( count( $t_filter['target_version'] ) == 0 ) {
            echo lang_get( 'any' );
        } else {
            $t_first_flag = true;
            foreach( $t_filter['target_version'] as $t_current ) {
                $t_current = stripslashes( $t_current );
                echo '<input type="hidden" name="target_version[]" value="' . string_display( $t_current ) . '" />';
                $t_this_string = '';
                if ( ( ( $t_current == META_FILTER_ANY ) && ( is_numeric( $t_current ) ) ) 
                    || ( is_blank( $t_current ) ) ) {
                    $t_any_found = true;
                } else if ( META_FILTER_NONE == $t_current ) {
                    $t_this_string = lang_get( 'none' );
                } else {
                    $t_this_string = string_display( $t_current );
                }
                if ( $t_first_flag != true ) {
                    $t_output = $t_output . '<br />';
                } else {
                    $t_first_flag = false;
                }
                $t_output = $t_output . $t_this_string;
            }
            if ( true == $t_any_found ) {
                echo lang_get( 'any' );
            } else {
                echo $t_output;
            }
        }
    } else {
        echo '&nbsp;';
    }
    echo '</td>' . "\n";
    if ( $t_filter_cols > 8 ) {
        echo '<td class="small-caption" valign="top" colspan="' . ( $t_filter_cols - 7 ) . '">&nbsp;</td>' . "\n";
    }
    echo '</tr>' . "\n";
    echo '<tr class="' . $t_trclass . '">' . "\n";
    echo '<td class="small-caption" valign="top">';
    echo '<a href="' . $t_filters_url . 'per_page" id="per_page_filter">' . lang_get( 'show' ) . ':</a>';
    echo '</td>' . "\n";
    echo '<td class="small-caption" valign="top">';
    echo '<a href="' . $t_filters_url . 'view_state" id="view_state_filter">' . lang_get( 'view_status' ) . ':</a>';
    echo '</td>' . "\n";
    echo '<td class="small-caption" valign="top">';
    echo '<a href="' . $t_filters_url . 'sticky_issues" id="sticky_issues_filter">' . lang_get( 'sticky' ) . ':</a>';
    echo '</td>' . "\n";
    echo '<td class="small-caption" valign="top">';
    echo '<a href="' . $t_filters_url . 'highlight_changed" id="highlight_changed_filter">' . lang_get( 'changed' ) . ':</a>';
    echo '</td>' . "\n";
    echo '<td class="small-caption" valign="top" colspan="2">';
    echo '<a href="' . $t_filters_url . 'do_filter_by_date" id="do_filter_by_date_filter">' . lang_get( 'use_date_filters' ) . ':</a>';
    echo '</td>' . "\n";
    echo '<td class="small-caption" valign="top" colspan="2">';
    echo '<a href="' . $t_filters_url . 'relationship_type" id="relationship_type_filter">' . lang_get( 'bug_relationships' ) . ':</a>';
    echo '</td>' . "\n";
    if ( $t_filter_cols > 8 ) {
        echo '<td class="small-caption" valign="top" colspan="' . ( $t_filter_cols - 8 ) . '">&nbsp;</td>' . "\n";
    }
    echo '</tr>' . "\n";
    echo '<tr class="row-1">' . "\n";
    echo '<td class="small-caption" valign="top" id="per_page_filter_target">';
    echo $t_filter['per_page'];
    echo '<input type="hidden" name="per_page" value="' . $t_filter['per_page'] . '" />';
    echo '</td>' . "\n";
    echo '<td class="small-caption" valign="top" id="view_state_filter_target">';
    if ( VS_PUBLIC === $t_filter['view_state'] ) {
        echo lang_get( 'public' );
    } else if ( VS_PRIVATE === $t_filter['view_state'] ) {
        echo lang_get( 'private' );
    } else {
        echo lang_get( 'any' );
        $t_filter['view_state'] = META_FILTER_ANY;
    }
    echo '<input type="hidden" name="view_state" value="' . $t_filter['view_state'] . '" />';
    echo '</td>' . "\n";
    echo '<td class="small-caption" valign="top" id="sticky_issues_filter_target">';
    $t_sticky_filter_state = gpc_string_to_bool( $t_filter['sticky_issues'] )  ;
    echo ( $t_sticky_filter_state ? lang_get( 'yes' ) : lang_get( 'no' ) );
    echo '<input type="hidden" name="sticky_issues" value="' . ( $t_sticky_filter_state ? 'on' : 'off' ) . '" />' ;
    echo '</td>' . "\n";
    echo '<td class="small-caption" valign="top" id="highlight_changed_filter_target">';
    echo $t_filter['highlight_changed'];
    echo '<input type="hidden" name="highlight_changed" value="' . $t_filter['highlight_changed'] . '" />';
    echo '</td>' . "\n";
    echo '<td class="small-caption" valign="top" colspan="2" id="do_filter_by_date_filter_target">';
    if ( ( ON == config_get( 'dhtml_filters' ) ) && ( ON == config_get( 'use_javascript' ) ) ){
        echo '<script type="text/javascript" language="JavaScript">' . "\n";
        echo '<!--' . "\n";
        echo 'function SwitchDateFields() {' . "\n";
        echo 'document.plugins_importexport.start_month.disabled = ! document.plugins_importexport.do_filter_by_date.checked;' . "\n";
        echo 'document.plugins_importexport.start_day.disabled = ! document.plugins_importexport.do_filter_by_date.checked;' . "\n";
        echo 'document.plugins_importexport.start_year.disabled = ! document.plugins_importexport.do_filter_by_date.checked;' . "\n";
        echo 'document.plugins_importexport.end_month.disabled = ! document.plugins_importexport.do_filter_by_date.checked;' . "\n";
        echo 'document.plugins_importexport.end_day.disabled = ! document.plugins_importexport.do_filter_by_date.checked;' . "\n";
        echo 'document.plugins_importexport.end_year.disabled = ! document.plugins_importexport.do_filter_by_date.checked;' . "\n";
        echo 'return true;' . "\n";
        echo '}' . "\n";
        echo '// -->' . "\n";
        echo '</script>' . "\n";
    }
    if ( 'on' == $t_filter['do_filter_by_date'] ) {
        echo '<input type="hidden" name="do_filter_by_date" value="' . $t_filter['do_filter_by_date'] . '" />' . "\n";
        echo '<input type="hidden" name="start_month" value="' . $t_filter['start_month'] . '" />' . "\n";
        echo '<input type="hidden" name="start_day" value="' . $t_filter['start_day'] . '" />' . "\n";
        echo '<input type="hidden" name="start_year" value="' . $t_filter['start_year'] . '" />' . "\n";
        echo '<input type="hidden" name="end_month" value="' . $t_filter['end_month'] . '" />' . "\n";
        echo '<input type="hidden" name="end_day" value="' . $t_filter['end_day'] . '" />' . "\n";
        echo '<input type="hidden" name="end_year" value="' . $t_filter['end_year'] . '" />' . "\n";
        $t_chars = preg_split( '//', config_get( 'short_date_format' ), -1, PREG_SPLIT_NO_EMPTY );
        $t_time = mktime( 0, 0, 0, $t_filter['start_month'], $t_filter['start_day'], $t_filter['start_year'] );
        foreach( $t_chars as $t_char ) {
            if ( strcasecmp( $t_char, "M" ) == 0 ) {
                echo ' ';
                echo date( 'F', $t_time );
            }
            if ( strcasecmp( $t_char, "D" ) == 0 ) {
                echo ' ';
                echo date( 'd', $t_time );
            }
            if ( strcasecmp( $t_char, "Y" ) == 0 ) {
                echo ' ';
                echo date( 'Y', $t_time );
            }
        }
        echo ' - ';
        $t_time = mktime( 0, 0, 0, $t_filter['end_month'], $t_filter['end_day'], $t_filter['end_year'] );
        foreach( $t_chars as $t_char ) {
            if ( strcasecmp( $t_char, "M" ) == 0 ) {
                echo ' ';
                echo date( 'F', $t_time );
            }
            if ( strcasecmp( $t_char, "D" ) == 0 ) {
                echo ' ';
                echo date( 'd', $t_time );
            }
            if ( strcasecmp( $t_char, "Y" ) == 0 ) {
                echo ' ';
                echo date( 'Y', $t_time );
            }
        }
    } else {
        echo lang_get( 'no' );
    }
    echo '</td>' . "\n";
    echo '<td class="small-caption" valign="top" colspan="2" id="relationship_type_filter_target">';
    echo '<input type="hidden" name="relationship_type" value="' . $t_filter['relationship_type'] . '" />';
    echo '<input type="hidden" name="relationship_bug" value="' . $t_filter['relationship_bug'] . '" />';
    $c_rel_type = $t_filter['relationship_type'];
    $c_rel_bug = $t_filter['relationship_bug'];
    if ( -1 == $c_rel_type || 0 == $c_rel_bug ) {
        echo lang_get( 'any' );
    } else {
        echo relationship_get_description_for_history ($c_rel_type) . ' ' . $c_rel_bug;
    }
    echo '</td>' . "\n";
    if ( $t_filter_cols > 8 ) {
        echo '<td class="small-caption" valign="top" colspan="' . ( $t_filter_cols - 8 ) . '">&nbsp;</td>' . "\n";
    }
    echo '</tr>' . "\n";
    if ( ON == config_get( 'filter_by_custom_fields' ) ) {
        if ( count( $t_accessible_custom_fields_ids ) > 0 ) {
            $t_per_row = config_get( 'filter_custom_fields_per_row' );
            $t_num_fields = count( $t_accessible_custom_fields_ids ) ;
            $t_row_idx = 0;
            $t_col_idx = 0;
            
            $t_fields = "";
            $t_values = "";
            
            for ( $i = 0; $i < $t_num_fields; $i++ ) {
                if ( $t_col_idx == 0 ) {
                    $t_fields = '<tr class="' . $t_trclass . '">';
                    $t_values = '<tr class="row-1">';
                }
                
                if ( isset( $t_accessible_custom_fields_names[ $i ] ) ) {
                    $t_fields .= '<td class="small-caption" valign="top"> ';
                    $t_fields .= '<a href="' . $t_filters_url . 'custom_field_' . $t_accessible_custom_fields_ids[$i] . '[]" id="custom_field_'. $t_accessible_custom_fields_ids[$i] .'_filter">';
                    $t_fields .= string_display( lang_get_defaulted( $t_accessible_custom_fields_names[$i] ) );
                    $t_fields .= '</a> </td> ';
                }
                $t_output = '';
                $t_any_found = false;
                
                $t_values .= '<td class="small-caption" valign="top" id="custom_field_' . $t_accessible_custom_fields_ids[$i] . '_filter_target"> ' ;
                if ( !isset( $t_filter['custom_fields'][$t_accessible_custom_fields_ids[$i]] ) ) {
                    $t_values .= lang_get( 'any' );
                } else {
                    if ( $t_accessible_custom_fields_types[$i] == CUSTOM_FIELD_TYPE_DATE ) {
                        $t_field_id = $t_accessible_custom_fields_ids[$i];
                        $t_js_toggle_func = "toggle_custom_date_field_" . $t_field_id . "_controls" ;
                        if ( ( ON == config_get( 'dhtml_filters' ) ) && ( ON == config_get( 'use_javascript' ) ) ) {
                            echo '<script type="text/javascript" language="JavaScript">' . "\n";
                            echo '<!--' . "\n";
                            echo 'function ' . $t_js_toggle_func . '_start(disable) {' . "\n";
                            echo 'document.plugins_importexport.custom_field_' . $t_field_id . '_start_year.disabled = disable ;' . "\n";
                            echo 'document.plugins_importexport.custom_field_' . $t_field_id . '_start_month.disabled = disable ;' . "\n";
                            echo 'document.plugins_importexport.custom_field_' . $t_field_id . '_start_day.disabled = disable ;' . "\n";
                            echo '};' . "\n";
                            echo 'function ' . $t_js_toggle_func . '_end(disable) {' . "\n";
                            echo 'document.plugins_importexport.custom_field_' . $t_field_id . '_end_year.disabled = disable ;' . "\n";
                            echo 'document.plugins_importexport.custom_field_' . $t_field_id . '_end_month.disabled = disable ;' . "\n";
                            echo 'document.plugins_importexport.custom_field_' . $t_field_id . '_end_day.disabled = disable ;' . "\n";
                            echo '};' . "\n";
                            echo 'function ' . $t_js_toggle_func . '() {' . "\n";
                            echo 'switch (document.plugins_importexport.custom_field_' . $t_field_id . '_control.selectedIndex) {' . "\n";
                            echo 'case ' . CUSTOM_FIELD_DATE_ANY . ':' . "\n";
                            echo 'case ' . CUSTOM_FIELD_DATE_NONE . ':' . "\n";
                            echo $t_js_toggle_func . '_start(true);' . "\n";
                            echo $t_js_toggle_func . '_end(true);' . "\n";
                            echo 'break ;' . "\n";
                            echo 'case ' . CUSTOM_FIELD_DATE_BETWEEN . ':' . "\n";
                            echo $t_js_toggle_func . '_start(false);' . "\n";
                            echo $t_js_toggle_func . '_end(false);' . "\n";
                            echo 'break ;' . "\n";
                            echo 'default:' . "\n";
                            echo $t_js_toggle_func . '_start(false) ;' . "\n";
                            echo $t_js_toggle_func . '_end(true) ;' . "\n";
                            echo 'break ;' . "\n";
                            echo '}' . "\n";
                            echo '}' . "\n";
                            echo '// -->' . "\n";
                            echo '</script>' . "\n";
                        }       
                        $t_short_date_format = config_get( 'short_date_format' );
                        if ( !isset( $t_filter['custom_fields'][$t_accessible_custom_fields_ids[$i]][1] ) ) {
                            $t_filter['custom_fields'][$t_accessible_custom_fields_ids[$i]][1] = 0;
                        }
                        $t_start = date( $t_short_date_format, $t_filter['custom_fields'][$t_accessible_custom_fields_ids[$i]][1] );
                        
                        if ( !isset( $t_filter['custom_fields'][$t_accessible_custom_fields_ids[$i]][2] ) ) {
                            $t_filter['custom_fields'][$t_accessible_custom_fields_ids[$i]][2] = 0;
                        }
                        $t_end = date( $t_short_date_format, $t_filter['custom_fields'][$t_accessible_custom_fields_ids[$i]][2] );
                        switch ($t_filter['custom_fields'][$t_accessible_custom_fields_ids[$i]][0]) {
                          case CUSTOM_FIELD_DATE_ANY:
                            $t_values .= lang_get( 'any' ) ;
                            break;
                          case CUSTOM_FIELD_DATE_NONE:
                            $t_values .= lang_get( 'none' ) ;
                            break;
                          case CUSTOM_FIELD_DATE_BETWEEN:
                            $t_values .= lang_get( 'between' ) . '<br />';
                            $t_values .= $t_start . '<br />' . $t_end;
                            break;
                          case CUSTOM_FIELD_DATE_ONORBEFORE:
                            $t_values .= lang_get( 'on_or_before' ) . '<br />';
                            $t_values .= $t_end;
                            break;
                          case CUSTOM_FIELD_DATE_BEFORE:
                            $t_values .= lang_get( 'before' ) . '<br />';
                            $t_values .= $t_end;
                            break;
                          case CUSTOM_FIELD_DATE_ON:
                            $t_values .= lang_get( 'on' ) . '<br />';
                            $t_values .= $t_start;
                            break;
                          case CUSTOM_FIELD_DATE_AFTER:
                            $t_values .= lang_get( 'after' ) . '<br />';
                            $t_values .= $t_start;
                            break ;
                          case CUSTOM_FIELD_DATE_ONORAFTER:
                            $t_values .= lang_get( 'on_or_after' ) . '<br />';
                            $t_values .= $t_start;
                            break ;
                        }
                    } else {
                        $t_first_flag = true;
                        foreach( $t_filter['custom_fields'][$t_accessible_custom_fields_ids[$i]] as $t_current ) {
                            $t_current = stripslashes( $t_current );
                            $t_this_string = '';
                            if ( ( ( $t_current == META_FILTER_ANY ) && ( is_numeric( $t_current ) ) ) 
                                || ( is_blank( $t_current ) ) ) {
                                $t_any_found = true;
                            } else if ( ( META_FILTER_NONE == $t_current ) && ( is_numeric( $t_current ) ) ) {
                                $t_this_string = lang_get( 'none' );
                            } else {
                                $t_this_string = string_display( $t_current );
                            }
                            
                            if ( $t_first_flag != true ) {
                                $t_output = $t_output . '<br />';
                            } else {
                                $t_first_flag = false;
                            }
                            
                            $t_output = $t_output . $t_this_string;
                            $t_values .= '<input type="hidden" name="custom_field_'.$t_accessible_custom_fields_ids[$i].'[]" value="'.string_display( $t_current ).'" />';
                        }
                    }
                    
                    if ( true == $t_any_found ) {
                        $t_values .= lang_get( 'any' );
                    } else {
                        $t_values .= $t_output;
                    }
                }
                $t_values .= ' </td>';
                
                $t_col_idx++;
                
                if ( $t_col_idx == $t_per_row ) {
                    if ( $t_filter_cols > $t_per_row ) {
                        $t_fields .= '<td colspan="' . ($t_filter_cols - $t_per_row ) . '">&nbsp;</td> ';
                        $t_values .= '<td colspan="' . ($t_filter_cols - $t_per_row) . '">&nbsp;</td> ';
                    }
                    
                    $t_fields .= '</tr>' . "\n";
                    $t_values .= '</tr>' . "\n";
                    
                    echo $t_fields;
                    echo $t_values;
                    
                    $t_col_idx = 0;
                    $t_row_idx++;
                }
            }
            

            if ( $t_col_idx > 0 ) {
                if ( $t_col_idx < $t_per_row ) {
                    $t_fields .= '<td colspan="' . ($t_per_row - $t_col_idx) . '">&nbsp;</td> ';
                    $t_values .= '<td colspan="' . ($t_per_row - $t_col_idx) . '">&nbsp;</td> ';
                }
                
                if ( $t_filter_cols > $t_per_row ) {
                    $t_fields .= '<td colspan="' . ($t_filter_cols - $t_per_row ) . '">&nbsp;</td> ';
                    $t_values .= '<td colspan="' . ($t_filter_cols - $t_per_row) . '">&nbsp;</td> ';
                }
                
                $t_fields .= '</tr>' . "\n";
                $t_values .= '</tr>' . "\n";
                
                echo $t_fields;
                echo $t_values;
            }
        }
    }
    echo '<tr class="row-1">' . "\n";
    echo '<td class="small-caption" valign="top">';
    echo '<a href="' . $t_filters_url . 'show_sort" id="show_sort_filter">' . lang_get( 'sort' ) . ':</a>';
    echo '</td>' . "\n";
    echo '<td class="small-caption" valign="top" colspan="2" id="show_sort_filter_target">';
    $t_sort_fields = split( ',', $t_filter['sort'] );
    $t_dir_fields = split( ',', $t_filter['dir'] );

    for ( $i=0; $i<2; $i++ ) {
        if ( isset( $t_sort_fields[$i] ) ) {
            if ( 0 < $i ) {
                echo ", ";
            }
            $t_sort = $t_sort_fields[$i];
            if ( strpos( $t_sort, 'custom_' ) === 0 ) {
                $t_field_name = string_display( lang_get_defaulted( substr( $t_sort, strlen( 'custom_' ) ) ) );
            } else {
                $t_field_name = string_get_field_name( $t_sort );
            }

            echo $t_field_name . ' ' . lang_get( 'bugnote_order_' . strtolower( $t_dir_fields[$i] ) );
            echo '<input type="hidden" name="sort_' . $i . '" value="' . $t_sort_fields[$i] . '" />';
            echo '<input type="hidden" name="dir_' . $i . '" value="' . $t_dir_fields[$i] . '" />';
        } 
    }
    echo '</td>' . "\n";
    echo '<td class="small-caption" valign="top">';
    echo '<a href="' . $t_filters_url . 'project_id" id="project_id_filter">' . lang_get( 'email_project' ) . ':</a>';
    echo '</td>' . "\n";
    echo '<td class="small-caption" valign="top" colspan="2" id="project_id_filter_target">';
    $t_output = '';
    if ( !is_array( $t_filter['project_id'] ) ) {
        $t_filter['project_id'] = Array( $t_filter['project_id'] );
    }
    if ( count( $t_filter['project_id'] ) == 0 ) {
        echo lang_get( 'current' );
    } else {
        $t_first_flag = true;
        foreach( $t_filter['project_id'] as $t_current ) {
            echo '<input type="hidden" name="project_id[]" value="' . $t_current . '" />';
            $t_this_name = '';
            if ( META_FILTER_CURRENT == $t_current ) {
                $t_this_name = lang_get( 'current' );
            } else {
                $t_this_name = project_get_name( $t_current );
            }
            if ( $t_first_flag != true ) {
                $t_output = $t_output . '<br />';
            } else {
                $t_first_flag = false;
            }
            $t_output = $t_output . $t_this_name;
        }
        echo $t_output;
    }
    echo '</td>' . "\n";
    if ( $t_filter_cols > 6 ) {
        echo '<td class="small-caption" valign="top" colspan="' . ( $t_filter_cols - 5 ) . '">&nbsp;</td>' . "\n";
    }
    echo '</tr>' . "\n";
    echo '<tr>' . "\n";
    echo '<td colspan="2">';
    echo lang_get( 'search' ) . ':';
    echo '<input type="text" size="16" name="search" value="' . string_html_specialchars( $t_filter['search'] ) . '" />';
    echo '</td>' . "\n";
    echo '<td class="center" colspan="' . ( $t_filter_cols - 6 ) . '"> <!-- use this label for padding --></td>' . "\n";
    echo '<td class="right" colspan="4"></td>' . "\n";
    echo '</tr></table>' . "\n";
    echo '<script type="text/javascript" language="JavaScript">' . "\n";
    echo '<!--' . "\n";
    echo 'var string_loading = \'Chargement en cours...\';' . "\n";
    echo '// -->' . "\n";
    echo '</script>' . "\n";
    echo '<script type="text/javascript" language="JavaScript" src="javascript/xmlhttprequest.js"></script>' . "\n";
    echo '<script type="text/javascript" language="JavaScript" src="javascript/addLoadEvent.js"></script>' . "\n";
    echo '<script type="text/javascript" language="JavaScript">' . "\n";
    echo '<!--' . "\n";
    echo 'var processURI    = \'./return_dynamic_filters.php\';' . "\n";
    echo 'var liveReq = false;' . "\n";
    echo 'if (window.XMLHttpRequest) {' . "\n";
    echo 'liveReq = new XMLHttpRequest();' . "\n";
    echo '}' . "\n";
    echo 'function liveReqDoReq() {' . "\n";
    echo 'if (liveReq && liveReq.readyState < 4) {' . "\n";
    echo 'liveReq.abort();' . "\n";
    echo '}' . "\n";
    echo 'if (window.XMLHttpRequest) {' . "\n";
    echo '} else if (window.ActiveXObject) {' . "\n";
    echo 'liveReq = new ActiveXObject("Microsoft.XMLHTTP");' . "\n";
    echo '}' . "\n";
    echo 'name = this.id;' . "\n";
    echo 'liveReq.onreadystatechange = function(){liveReqProcessReqChange(name);};' . "\n";
    echo 'liveReq.open("GET", processURI + "?view_type=advanced&filter_target=" + this.id);' . "\n";
    echo 'document.getElementById(this.id+\'_target\').innerHTML = string_loading;' . "\n";
    echo 'liveReq.send(null);' . "\n";
    echo 'return false;' . "\n";
    echo '}' . "\n";
    echo 'function liveReqProcessReqChange(name) {' . "\n";
    echo 'if (liveReq.readyState == 4) {' . "\n";
    echo 'document.getElementById(name+\'_target\').innerHTML = liveReq.responseText;' . "\n";
    echo 'replaceWithContent(name);' . "\n";
    echo '}' . "\n";
    echo '}' . "\n";
    echo 'function replaceWithContent(id){' . "\n";
    echo 'tag = document.getElementById(id);' . "\n";
    echo 'if (!tag) return false;' . "\n";
    echo 't_parent = tag.parentNode;' . "\n";
    echo 'if (!t_parent) return false;' . "\n";
    echo 'for(var i=0; i <tag.childNodes.length; i++){' . "\n";
    echo 'child = tag.childNodes[i].cloneNode(true);' . "\n";
    echo 't_parent.insertBefore(child, tag);' . "\n";
    echo '}' . "\n";
    echo 't_parent.removeChild(tag);' . "\n";
    echo '}' . "\n";
    echo 'function labelInit(){' . "\n";
    echo 'if (document.getElementById && 	(window.XMLHttpRequest || window.ActiveXObject)) {' . "\n";
    echo 't_form = document.getElementById("plugins_importexport");' . "\n";
    echo 'if (!t_form) return false;' . "\n";
    echo 't_links = t_form.getElementsByTagName("a");' . "\n";
    echo 'if (!t_links) return false;' . "\n";
    echo 'for(var i=0; i < t_links.length; i++){' . "\n";
    echo 'var t_link = t_links[i];' . "\n";
    echo 'if (t_link.id.substring((t_link.id.length - 7), t_link.id.length) == "_filter"){' . "\n";
    echo 'if (document.getElementById(t_link.id+\'_target\')){' . "\n";
    echo 't_link.onclick = liveReqDoReq;' . "\n";
    echo '} else {' . "\n";
    echo 'alert("missing target for:" +t_link.id);' . "\n";
    echo '}' . "\n";
    echo '}' . "\n";
    echo '}' . "\n";
    echo '}' . "\n";
    echo '}' . "\n";
    echo 'addLoadEvent(labelInit);' . "\n";
    echo '// -->' . "\n";
    echo '</script>' . "\n";
}

?>