<?php

/**
 * Import/Export plugin
 *
 *
 * Created: 2007-05-11
 * Last update: 2007-05-18
 *
 * @link http://deboutv.free.fr/mantis/
 * @author DEBOUT Vincent  <deboutv@free.fr>
 */

$t_core_path = config_get( 'core_path' );

require_once( $t_core_path.'current_user_api.php' );
require_once( $t_core_path.'bug_api.php' );
require_once( $t_core_path.'string_api.php' );
require_once( $t_core_path.'date_api.php' );
require_once( $t_core_path.'icon_api.php' );
require_once( $t_core_path.'columns_api.php' );

function print_plugins_importexport_link( $p_id = 0 ) {
    $t_access_level = user_get_access_level( auth_get_current_user_id(), helper_get_current_project() );
    $t_level = config_get( 'plugins_pluginmanager_importexport_threshold', PLUGINS_PLUGINMANAGER_CONFIGURE_THRESHOLD_DEFAULT );
    if ( $t_access_level >= $t_level ) {
        if ( $p_id == 0 ) {
            print_bracket_link( 'plugins_page.php?plugin=importexport', lang_get( 'plugins_importexport_link' ), false );
        } else {
            print_bracket_link( 'plugins_page.php?plugin=importexport&step=4&action=export&bug_arr[]=' . $p_id, lang_get( 'plugins_importexport_export_link' ), false );
        }
    }
}

function plugins_importexport_print_bug_result_list() {
    echo '<table id="buglist" class="width100" cellspacing="1">' . "\n";
    echo '  <tr>' . "\n";
    echo '    <td class="form-title" colspan="2">';
    echo lang_get( 'viewing_bugs_title' );
    echo '</td>' . "\n";
    echo '    <td class="right" colspan="2"></td>' . "\n";
    echo '  </tr>' . "\n";
    echo '  <tr class="row-category">' . "\n";
    echo '    <td>' . lang_get( 'plugins_importexport_action' ) . '</td>' . "\n";
    echo '    <td>' . lang_get( 'id' ) . '</td>' . "\n";
    echo '    <td>' . lang_get( 'summary' ) . '</td>' . "\n";
    echo '    <td>' . lang_get( 'plugins_importexport_result' ) . '</td>' . "\n";
    echo '  </tr>' . "\n";
    echo '  <tr><td class="spacer" colspan="4">&nbsp;</td></tr>' . "\n";
    $t_count = gpc_get_int( 'count', 0 );
    for( $i=0; $i<$t_count; $i++ ) {
        if ( gpc_get_bool( 'select_' . $i ) ) {
            echo '  <tr>' . "\n";
            $t_id = gpc_get_int( 'id_' . $i, 0 );
            $t_summary = gpc_get_string( 'summary_' . $i, '' );
            $t_result = false;
            if ( $t_id == 0 ) {
                echo '    <td class="center">' . lang_get( 'plugins_importexport_add' ) . '</td>' . "\n";
                $t_result = plugins_importexport_add_bug( $t_id, $i );
                echo '    <td>';
                print_bug_link( $t_id, false );
                echo '</td>' . "\n";
            } else {
                echo '    <td class="center">' . lang_get( 'plugins_importexport_update' ) . '</td>' . "\n";
                $t_result = plugins_importexport_update_bug( $t_id, $i );
                echo '    <td>';
                print_bug_link( $t_id, false );
                echo '</td>' . "\n";
            }
            echo '    <td>' . $t_summary . '</td>' . "\n";
            if ( $t_result ) {
                echo '    <td class="center">' . lang_get( 'plugins_importexport_success' ) . '</td>' . "\n";
            } else {
                echo '    <td class="center">' . lang_get( 'plugins_importexport_fail' ) . '</td>' . "\n";
            }
            echo '  </tr>' . "\n";
        }
    }
    echo '</table>' . "\n";
}

function plugins_importexport_print_bug_list( $p_rows, $p_action = 'export' ) {
    $t_columns = array( 'selection', 'id', 'category', 'status', 'last_updated', 'summary' );
    $col_count = count( $t_columns );
    echo '<table id="buglist" class="width100" cellspacing="1">' . "\n";
    echo '  <tr>' . "\n";
    echo '    <td class="form-title" colspan="' . ( $col_count - 2 ) . '">';
    echo lang_get( 'viewing_bugs_title' );
    echo '</td>' . "\n";
    echo '    <td class="right" colspan="2"></td>' . "\n";
    echo '  </tr>' . "\n";
    echo '  <tr class="row-category">' . "\n";
    foreach( $t_columns as $t_column ) {
        $t_title_function = 'print_column_title';
        echo '    <td>';
        helper_call_custom_function( $t_title_function, array( $t_column, COLUMNS_TARGET_CSV_PAGE ) );
        echo '</td>' . "\n";
    }
    echo '  </tr>' . "\n";
    echo '  <tr><td class="spacer" colspan="<?php echo $col_count; ?>"> &nbsp; </td></tr>' . "\n";

    if ( $p_action == 'export' ) {
        plugins_importexport_write_bug_rows( $p_rows, $t_columns );
    } else {
        plugins_importexport_write_bug_rows_import( $p_rows, $t_columns );
    }

    echo '  <tr>' . "\n";
    echo '    <td class="left" colspan="' . ( $col_count - 2 ) . '">';
    if ( ON == config_get( 'use_javascript' ) ) {
        echo '<input type="checkbox" name="all_bugs" value="all" onclick="checkall(\'plugins_importexport\', this.form.all_bugs.checked)" /><span class="small">"' . lang_get( 'select_all' ) . '</span>';
    }

    echo '</td>' . "\n";
    echo '    <td class="right" colspan="2"><input type="hidden" name="count" value="' . sizeof( $p_rows ) . '" /></td>' . "\n";
    echo '  </tr></table>' . "\n";
}

function plugins_importexport_write_bug_rows( $p_rows, $t_columns ) {
    $t_in_stickies = true;
    
    $t_rows = sizeof( $p_rows ); 
    for( $i=0; $i < $t_rows; $i++ ) {
        $t_row = $p_rows[$i];
        
        if ( ( 0 == $t_row['sticky'] ) && ( 0 == $i ) ) {
            $t_in_stickies = false;
        }
        if ( ( 0 == $t_row['sticky'] ) && $t_in_stickies ) {
            echo '<tr>' . "\n";
            echo '<td class="left" colspan="' . sizeof( $t_columns ) . '" bgcolor="#999999">&nbsp;</td>' . "\n";
            echo '</tr>' . "\n";
            $t_in_stickies = false;
        }
        $status_color = get_status_color( $t_row['status'] );

        echo '<tr bgcolor="', $status_color, '" border="1">';

        foreach( $t_columns as $t_column ) {
            $t_column_value_function = 'print_column_value';
            helper_call_custom_function( $t_column_value_function, array( $t_column, $t_row ) );
        }

        echo '</tr>';
    }
}

function plugins_importexport_write_bug_rows_import( $p_rows, $t_columns ) {
    
    $t_rows = sizeof( $p_rows ); 
    for( $i=0; $i < $t_rows; $i++ ) {
        $t_row = $p_rows[$i];
        
        $status_color = get_status_color( $t_row['status'] );

        echo '<tr bgcolor="', $status_color, '" border="1">';

        foreach( $t_columns as $t_column ) {
            if ( $t_column == 'selection' ) {
                echo '<td><input type="checkbox" name="select_' . $i . '" /></td>';
            } else if ( $t_column == 'summary' ) {
                $t_summary = string_attribute( $t_row['summary'] );
                $t_description = string_attribute( $t_row['description'] );
                echo '<td class="left"><a title="', $t_description, '">', $t_summary;
                echo '</a></td>';
            } else {
                if ( ( $t_column == 'category' && $t_row['project_id'] != 0 ) || $t_column != 'category' ) {
                    $t_function = 'print_column_' . $t_column;
                    $t_function( $t_row );
                } else {
                    echo '<td></td>' . "\n";
                }
            }
        }
        foreach( $t_row as $t_key => $t_value ) {
            echo '<input type="hidden" name="' . $t_key . '_' . $i . '" value="' . $t_value . '" />' . "\n";
        }

        echo '</tr>';
    }
}

function plugins_importexport_get_format_list() {
    $t_formats = array();
    $t_directory = dirname( dirname( __FILE__ ) ) . DIRECTORY_SEPARATOR . 'format';
    $t_dir = opendir( $t_directory );
    $t_lang = lang_get_current();
    while( ( $t_file = readdir( $t_dir ) ) !== false ) {
        if ( is_dir( $t_directory . DIRECTORY_SEPARATOR . $t_file ) && $t_file != '.' && $t_file != '..' ) {
            if ( file_exists( $t_directory . DIRECTORY_SEPARATOR . $t_file . DIRECTORY_SEPARATOR . 'index.php' ) && file_exists( $t_directory . DIRECTORY_SEPARATOR . $t_file . DIRECTORY_SEPARATOR . 'info.php' ) ) {
                if ( file_exists( $t_directory . DIRECTORY_SEPARATOR . $t_file . DIRECTORY_SEPARATOR . 'lang' . DIRECTORY_SEPARATOR . 'strings_' . $t_lang . '.txt' ) ) {
                    include( $t_directory . DIRECTORY_SEPARATOR . $t_file . DIRECTORY_SEPARATOR . 'lang' . DIRECTORY_SEPARATOR . 'strings_' . $t_lang . '.txt' );
                } else if ( file_exists( $t_directory . DIRECTORY_SEPARATOR . $t_file . DIRECTORY_SEPARATOR . 'lang' . DIRECTORY_SEPARATOR . 'strings_english.txt' ) ) {
                    include( $t_directory . DIRECTORY_SEPARATOR . $t_file . DIRECTORY_SEPARATOR . 'lang' . DIRECTORY_SEPARATOR . 'strings_english.txt' );
                }
                include( $t_directory . DIRECTORY_SEPARATOR . $t_file . DIRECTORY_SEPARATOR . 'info.php' );
                $t_format_function = 'plugins_importexport_format_' . $t_file;
                $t_format_info = $t_format_function();
                $t_formats[$t_file] = $t_format_info['name'] . ' '  . $t_format_info['version'];
            }
        }
    }
    return $t_formats;
}

function plugins_importexport_print_export_format() {
    $t_formats = plugins_importexport_get_format_list();
    asort( $t_formats );
    foreach( $t_formats as $t_key => $t_value ) {
        echo '<option value="' . $t_key . '">' . $t_value . '</option>' . "\n";
    }
}

function plugins_importexport_get_bug( $p_bug_id, $p_fields ) {
    $t_result = array();
    foreach( $p_fields as $t_field ) {
        if ( ereg( '^reporter_', $t_field ) || ereg( '^handler_', $t_field ) ) {
            $t_field = explode( '_', $t_field );
            $t_reporter_id = bug_get_field( $p_bug_id, $t_field[0] . '_id' );
            if ( $t_reporter_id != 0 ) {
                $t_result[] = user_get_field( $t_reporter_id, $t_field[1] );
            } else {
                $t_result[] = '';
            }
        } else if ( ereg( '^project_', $t_field ) ) {
            $t_field = explode( '_', $t_field );
            $t_project_id = bug_get_field( $p_bug_id, $t_field[0] . '_id' );
            $t_result[] = project_get_field( $t_project_id, $t_field[1] );
        } else if ( $t_field == 'description' || $t_field == 'steps_to_reproduce' || $t_field == 'additional_information' ) {
            $t_result[] = bug_get_text_field( $p_bug_id, $t_field );
        } else if ( ereg( '^custom_', $t_field ) ) {
            $t_field = str_replace( 'custom_', '', $t_field );
            $t_field_id = custom_field_get_id_from_name( $t_field );
            $t_res = custom_field_get_value( $t_field_id, $p_bug_id );
            if ( $t_res && custom_field_get_field( $t_field_id, 'type' ) == CUSTOM_FIELD_TYPE_DATE ) {
                $t_res = date( config_get( 'normal_date_format', $t_res ) );
            }
            $t_result[] = $t_res;
        } else if ( $t_field == 'bugnote' ) {
            $t_res = array();
            $t_bugnotes = bugnote_get_all_visible_bugnotes( $p_bug_id, user_get_access_level( auth_get_current_user_id() ), 'ASC', 0 );
            foreach( $t_bugnotes as $t_note_index => $t_bugnote ) {
                $t_note['id'] = $t_bugnote->id;
                $t_note['reporter_id'] = $t_bugnote->reporter_id;
                $t_note['note'] = $t_bugnote->note;
		$t_note['view_state'] = $t_bugnote->view_state;
		$t_note['date_submitted'] = date( config_get( 'normal_date_format', $t_bugnote->date_submitted ) );
		$t_note['last_modified'] = date( config_get( 'normal_date_format', $t_bugnote->last_modified ) );
                $t_res[] = $t_note;
            }
            $t_result[] = $t_res;
        } else {
            $t_res = bug_get_field( $p_bug_id, $t_field );
            $t_val = $t_field . '_enum_string';
            if ( config_is_set( $t_val ) ) {
                $t_res = get_enum_element( $t_field, $t_res );
            }
            if ( $t_field == 'date_submitted' || $t_field == 'last_updated' ) {
                $t_res = date( config_get( 'normal_date_format' ), $t_res );
            }
            $t_result[] = $t_res;
        }
    }
    return array( 'id' => $p_bug_id, 'columns' => $t_result );
}

function plugins_importexport_print_export_field_list() {
    global $g_mantis_is_11x_release; 
    
    $t_fields = array( 'id', 'priority', 'project_id', 'project_name', 'project_description', 'handler_id', 'handler_username', 'handler_realname', 'handler_email',
                      'reporter_id', 'reporter_username', 'reporter_realname', 'reporter_email', 'duplicate_id', 'severity', 'reproducibility', 'status', 'resolution',
                      'projection', 'category', 'date_submitted', 'last_updated', 'eta', 'os', 'os_build', 'platform', 'version', 'fixed_in_version', 'build',
                      'profile_id', 'view_state', 'summary', 'sponsorship_total', 'sticky', 'description', 'steps_to_reproduce',
                      'additional_information', 'bugnote' );
    if ( $g_mantis_is_11x_release ) {
        $t_fields[] = 'target_version';
    }
    $t_custom_ids = custom_field_get_ids();
    foreach( $t_custom_ids as $t_id ) {
        $t_fields[] = 'custom_' . custom_field_get_field( $t_id, 'name' );
    }
    $t_fields = plugins_importexport_translate( $t_fields );
    asort( $t_fields );
    foreach( $t_fields as $t_key => $t_value ) {
        echo '<option value="' . $t_key . '">' . $t_value . '</option>' . "\n";
    }
}

function plugins_importexport_translate( $p_fields ) {
    $t_result = array();
    foreach( $p_fields as $t_field ) {
        if ( ereg( 'project_', $t_field ) || ereg( 'handler_', $t_field ) ) {
            $t_val = explode( '_', $t_field );
            $t_result[$t_field] = lang_get( 'email_' . $t_val[0] ) . ' (' . lang_get( $t_val[1] ) . ')';
        } else if ( ereg( 'reporter_', $t_field ) ) {
            $t_val = explode( '_', $t_field );
            $t_result[$t_field] = lang_get( $t_val[0] ) . ' (' . lang_get( $t_val[1] ) . ')';
        } else if ( $t_field == 'last_updated' ) {
            $t_result['last_updated'] = lang_get( 'last_update' );
        } else if ( $t_field == 'os_build' ) {
            $t_result['os_build'] = lang_get( 'os' ) . ' (' . lang_get( 'build' ) . ')';
        } else if ( $t_field == 'profile_id' ) {
            $t_result['profile_id'] = lang_get( 'profile' );
        } else if ( $t_field == 'view_state' ) {
            $t_result['view_state'] = lang_get( 'view_status' );
        } else if ( $t_field == 'sticky' ) {
            $t_result['sticky'] = lang_get( 'sticky_issue' );
        } else if ( ereg( '^custom_', $t_field ) ) {
            $t_result[$t_field] = str_replace( 'custom_', '', $t_field );
        } else {
            $t_result[$t_field] = lang_get( $t_field );
        }
    }
    return $t_result;
}

?>
