<?php

/**
 * Import/Export plugin
 *
 *
 * Created: 2007-05-13
 * Last update: 2007-05-17
 *
 * @link http://deboutv.free.fr/mantis/
 * @author DEBOUT Vincent  <deboutv@free.fr>
 */

function StartElement( $p_parser, $p_name, $p_attrs ) {
    global $t_result;
    global $t_res;
    global $t_current;

    if ( $p_name == 'BUG' ) {
        $t_res = array();
        $t_res['id'] = 0;
        $t_res['sticky'] = 0;
        $t_res['status'] = NEW_;
        $t_res['resolution'] = OPEN;
        $t_res['project_id'] = helper_get_current_project();
    }
    $t_current = strtolower( $p_name );
}

function EndElement( $p_parser, $p_name ) {
    global $t_result;
    global $t_res;

    if ( $p_name == 'BUG' ) {
        $t_result[] = $t_res;
    }
}

function plugins_importexport_get_enum( $p_enum, $p_value ) {
    $string_var = lang_get(  $p_enum . '_enum_string' );

    $t_arr = explode_enum_string( $string_var );
    $t_arr_count = count( $t_arr );
    for( $i=0; $i<$t_arr_count; $i++ ) {
        $elem_arr = explode_enum_arr( $t_arr[$i] );
        if ( $elem_arr[1] == $p_value ) {
            return $elem_arr[0];
        }
    }
    return $p_value;
}

function CharacterData( $p_parser, $p_data ) {
    global $t_current;
    global $t_res;

    if ( trim( $p_data ) != '' ) {
        $t_res[$t_current] = $p_data;
        if ( $t_current == 'project_name' ) {
            $t_res['project_id'] = project_get_id_by_name( $p_data );
        }
        if ( $t_current == 'handler_username' ) {
            $t_res['handler_id'] = user_get_id_by_name( $p_data );
        }
        if ( $t_current == 'reporter_username' ) {
            $t_res['reporter_id'] = user_get_id_by_name( $p_data );
        }
        if ( $t_current == 'status' || $t_current == 'priority' || $t_current == 'severity' || $t_current == 'reproducibility' || $t_current == 'resolution' || $t_current == 'projection' || $t_current == 'eta' || $t_current == 'sponsorship' ) {
            $t_res[$t_current] = plugins_importexport_get_enum( $t_current, $p_data );
        }
    }
}

function plugins_importexport_xml_parse( $p_filename ) {
    global $t_result;
    
    $t_result = array();
    $t_parser = xml_parser_create();
    xml_set_element_handler( $t_parser, 'StartElement', 'EndElement' );
    xml_set_character_data_handler( $t_parser, 'CharacterData' );
    if ( !( $fp = fopen( $p_filename, 'r') ) ) {
        return $t_result;
    }

    while( $t_data = fread( $fp, 4096 ) ) {
        $t_data = preg_replace( '/^\n/', '', $t_data );
        if ( !xml_parse( $t_parser, $t_data, feof( $fp ) ) ) {
            return array();
        }
    }
    xml_parser_free( $t_parser );
    return $t_result;
}

?>
